/****************************************************************************
 *
 * NLPIR/ICTCLAS Lexical Analysis System DocExtractor Copyright (c) 2000-2015
 *     Dr. Kevin Zhang (Hua-Ping Zhang)
 *     All rights reserved.
 *
 * This file is the confidential and proprietary property of 
 * Kevin Zhang and the possession or use of this file requires 
 * a written license from the author.
 * Filename: 
 * Abstract:
 *          NLPIR.h: definition of the NLPIR lexical analysis system API
 * Author:   Kevin Zhang 
 *          Email: pipy_zhang@msn.com kevinzhang@bit.edu.cn
 *			Weibo: http://weibo.com/drkevinzhang
 *			Homepage: http://ictclas.nlpir.org
 * Date:     2013-12-19
 *
 * Notes:
 *                
 ****************************************************************************/

#ifdef DOCEXTRACTOR_EXPORTS
#define DOCEXTRACTOR_API extern "C" __declspec(dllexport)
#else
#define DOCEXTRACTOR_API extern "C" __declspec(dllimport)
#endif
#ifdef OS_LINUX
#define DOCEXTRACTOR_API extern "C"  
#endif
#include <stddef.h>

#define DOC_EXTRACT_TYPE_PERSON 0//
#define DOC_EXTRACT_TYPE_LOCATION 1//ĵ
#define DOC_EXTRACT_TYPE_ORGANIZATION 2//Ļ
#define DOC_EXTRACT_TYPE_KEYWORD 3//Ĺؼ
#define DOC_EXTRACT_TYPE_AUTHOR 4//
#define DOC_EXTRACT_TYPE_MEDIA 5//ý
#define DOC_EXTRACT_TYPE_COUNTRY 6//¶Ӧڹ
#define DOC_EXTRACT_TYPE_PROVINCE 7//¶Ӧʡ
#define DOC_EXTRACT_TYPE_ABSTRACT 8//µժҪ
#define DOC_EXTRACT_TYPE_POSITIVE 9//µд
#define DOC_EXTRACT_TYPE_NEGATIVE 10//µĸд
#define DOC_EXTRACT_TYPE_TEXT 11//ȥҳȱǩ
#define DOC_EXTRACT_TYPE_TIME 12//ʱ
#define DOC_EXTRACT_TYPE_USER 13//ûԶĴ࣬һԶ
//ԶʣΪDOC_EXTRACT_TYPE_USER+1DOC_EXTRACT_TYPE_USER+2...

#define PERSON_REQUIRED			0x0001
#define LOCATION_REQUIRED		0x0002
#define ORGANIZATION_REQUIRED	0x0004
#define KEYWORD_REQUIRED		0x0008
#define AUTHOR_REQUIRED			0x0010
#define MEDIA_REQUIRED			0x0100
#define COUNTRY_REQUIRED		0x0200
#define PROVINCE_REQUIRED		0x0400
#define ABSTRACT_REQUIRED		0x0800
#define SENTIWORD_REQUIRED		0x1000
#define SENTIMENT_REQUIRED		0x2000
#define TIME_REQUIRED			0x4000
#define HTML_REMOVER_REQUIRED	0x8000//ǷҪȥҳǩĹѡ
#define ALL_REQUIRED			0xffff

#define DOC_EXTRACT_DELIMITER "#"
#define DOC_EXTRACT_TYPE_MAX_LENGTH 600
#define GBK_CODE 0//Ĭ֧GBK
#define UTF8_CODE GBK_CODE+1//UTF8
#define BIG5_CODE GBK_CODE+2//BIG5
#define GBK_FANTI_CODE GBK_CODE+3//GBK룬
typedef  size_t DOC_PARSER_HANDLE;

/*-----------------------------------------------------------------------
* ܣʼ
* 
*		sPath-default path
*		nEncoding:
*		sLicenseCode - Ȩ
* أtrue - ɹfalse - ʧ
* עڽд˺֮ǰãִֻһΣ
------------------------------------------------------------------------*/
DOCEXTRACTOR_API int DE_Init(const char *sPath=0,int nEncoding=GBK_CODE,const char *sLicenseCode=0);

/*-----------------------------------------------------------------------
* ܣɵĵժҪ
* sText	    -[IN] ĵ
*	bool bSummaryNeeded=true-[IN]:ǷҪժҪ
*	
*		sUserDefPos:ûԶĴԱǣ֣ýãã֮ͬ#ָ"gms#gjtgj#g"

*		_tDocExtractResult	-[OUT] ĵExtract result
* עڽд˺ִж
------------------------------------------------------------------------*/
DOCEXTRACTOR_API DOC_PARSER_HANDLE DE_ParseDocE(const char *sText,const char *sUserDefPos=NULL,bool bSummaryNeeded=true,unsigned int nFuncRequired=ALL_REQUIRED);
//Process a text, and return DOC_PARSER_HANDLE
/*-----------------------------------------------------------------------
* ܣDE_ParseDocEУȡָȡĽ
* handle	    -[IN] DE_ParseDocEִк󷵻صHANDLE
*	int nDocExtractType[IN]:ǷȡĳȡͣDOC_EXTRACT_TYPE_PERSONʼĽ
* עDE_ParseDocEִ֮зɣ˺ִж
------------------------------------------------------------------------*/
DOCEXTRACTOR_API const char *DE_GetResult(DOC_PARSER_HANDLE handle,int nDocExtractType);

/*-----------------------------------------------------------------------
* ܣDE_ParseDocEУȡָµе÷
* handle	    -[IN] DE_ParseDocEִк󷵻صHANDLE
* ֵ÷
* עDE_ParseDocEִ֮зɣ˺ִж
------------------------------------------------------------------------*/
DOCEXTRACTOR_API int DE_GetSentimentScore(DOC_PARSER_HANDLE handle);
/*-----------------------------------------------------------------------
* ܣDE_ReleaseHandleͷDE_ParseDocEռݵĿռ
* handle	    -[IN] DE_ParseDocEִк󷵻صHANDLE
* ֵ
* עDE_ParseDocEִ֮зɣ˺ִж
------------------------------------------------------------------------*/
DOCEXTRACTOR_API void DE_ReleaseHandle(DOC_PARSER_HANDLE handle);


DOCEXTRACTOR_API unsigned int DE_ImportSentimentDict(const char *sFilename);//ûдʵ
////ûԶдʱÿһʣոȨأ磺ɲ -2;
//д´ʣûʵе룬ʶԶԾ
DOCEXTRACTOR_API unsigned int DE_ImportUserDict(const char *sFilename,bool bOverwite=false);//ûʵ
////ûԶĴʵ
/*********************************************************************
*
*  Func Name  : DE_ImportKeyBlackList
*
*  Description: Import keyword black list
*  Parameters : sFilename: Text filename for user defined blacklist dictionary, each line for a stop keyword
*				 sPOSBlacklist: ͣõĴбΪôбʵĴʲؼʷΧ
*								Ϊ#nr#ns#ʾnr,nsΪؼ
*  Returns    : The  number of  lexical entry imported successfully
*  Author     : Kevin Zhang
*  History    :
*              1.create 2014-6-26
*********************************************************************/

DOCEXTRACTOR_API unsigned int DE_ImportKeyBlackList(const char *sFilename, const char *sPOSBlacklist = 0);//ؼʺ
////ûԶĹؼʺ

/*********************************************************************
*
*  Func Name  : DE_AddUserWord
*
*  Description: add a word to the user dictionary ,example:
*				һһ·  key
*				ҪΪؼʵģǰ׺Ϊkey
*  Parameters : const char *sWord: 뵽ʱûʵصԣÿոָ
*
*  Returns    : 1,true ; 0,false
*
*  Author     :
*  History    :
*              1.create 2017/6/3
*********************************************************************/
DOCEXTRACTOR_API int DE_AddUserWord(const char *sWord);
/*********************************************************************
*
*  Func Name  : DE_CleanUserWord
*
*  Description: Clean all temporary added user words
*
*  Parameters :
*  Returns    : 1,true ; 0,false
*
*  Author     :
*  History    :
*              1.create 2017/6/3
*********************************************************************/
DOCEXTRACTOR_API int DE_CleanUserWord();
/*********************************************************************
*
*  Func Name  : DE_SaveTheUsrDic
*
*  Description: Save dictionary to file
*
*  Parameters :
*
*  Returns    : 1,true; 2,false
*
*  Author     :
*  History    :
*              1.create 2017/6/3
*********************************************************************/
DOCEXTRACTOR_API int DE_SaveTheUsrDic();

/*********************************************************************
*
*  Func Name  : DE_DelUsrWord
*
*  Description: delete a word from the  user dictionary
*
*  Parameters :
*  Returns    : -1, the word not exist in the user dictionary; else, the handle of the word deleted
*
*  Author     :
*  History    :
*              1.create 2017/6/3
*********************************************************************/
DOCEXTRACTOR_API int DE_DelUsrWord(const char *sWord);

/*----b--------------------------------------------------------------
* ܣɵĵժҪ
* sText	    -[IN] ĵ
*	bool bSummaryNeeded=true-[IN]:ǷҪժҪ
*	
*		_tDocExtractResult	-[OUT] ĵExtract result
* עڽд˺ִж
------------------------------------------------------------------------*/
DOCEXTRACTOR_API int  DE_ComputeSentimentDoc(const char *sText);


DOCEXTRACTOR_API void DE_Exit();

//ôϢ
DOCEXTRACTOR_API const char* DE_GetLastErrMsg();
